(function() {
	tpl.at = {};
	
	//
	// Add the titles of the test cases to the list to get them loaded to the table view
	//
	tpl.at.createData = function () {
		var acceptanceData = [
			{title:'timob2849', hasChild:true, level:'acceptance'},
			{title:'timob4314', hasChild:true, level:'acceptance'},
			{title:'timob4691', hasChild:true, level:'acceptance'},
			{title:'timob5807', hasChild:true, level:'acceptance'},
			{title:'timob6411', hasChild:true, level:'acceptance'},
			{title:'timob6828', hasChild:true, level:'acceptance'},
			{title:'timob6835', hasChild:true, level:'acceptance'},
			{title:'timob6973', hasChild:true, level:'acceptance'},
			{title:'timob7264', hasChild:true, level:'acceptance'},
			{title:'timob7718', hasChild:true, level:'acceptance'},
			{title:'timob7850', hasChild:true, level:'acceptance'},
			{title:'TIMOB7939', hasChild:true, level:"acceptance"},
			{title:'timob8014', hasChild:true, level:'acceptance'},
			{title:'timob9108', hasChild:true, level:'acceptance'},
			{title:'timob9639', hasChild:true, level:'acceptance'},
			{title:'timob9864', hasChild:true, level:'acceptance'},
			{title:'timob10036', hasChild:true, level:'acceptance'}
			
		]
		
		return acceptanceData;
	};
	
	//
	// TIMOB-7718: iOS: Network.Socket - app crashes with exception when listening for http requests
	//
	
	tpl.at.timob7718 = function(_window){
	var info = Ti.API.info;
	
 
		///=====================
		var socket = undefined;
		var connectedSockets = [];
		 
		function connect()
		{
		    if(socket === undefined || socket.state === Ti.Network.Socket.CLOSED)
		    {
		        socket = Titanium.Network.Socket.createTCP({
		            host:Ti.Platform.address,
		            port:8080,
		            listenQueueSize:100,
		            accepted: accepted,
		            closed: function(e)
		            {
		                info("Closed listener");
		            },
		            error: function(e)
		            {
		            	alert("Error encountered, check log");
		                Ti.API.error("Socket encountered error when listening");
		                Ti.API.error(" error code '" + e.errorCode + "'");
		                Ti.API.error(" error description '" + e.error + "'");
		            }
		        });
		        try
		        {
		            socket.listen();
		            info("###Listening on " + socket.host + ":" + socket.port);
		            alert("Listening on "+socket.host+":"+socket.port+" use your browser to connect");
		            socket.accept(acceptedCallbacks);
		        } catch (e)
		        {
		            info('Exception: ' + e);
		        }
		    }
		 
		}
		 
		function accepted(e)
		{
		    var sock = e.inbound;
		    info('ACCEPTED: ' + sock.host + ':' + sock.port);
		    Ti.Stream.pump(sock, pumpCallback, 1024, true);
		    socket.accept(acceptedCallbacks);
		}
		 
		 
		function pumpCallback(e)
		{
		    var sock = e.source;
		 
		    if(e.bytesProcessed == -1)
		    { // EOF
		        info("<EOF> - Closing the remote socket!");
		 
		        sock.close();
		    }
		    else
		    {
		        if(e.errorDescription === undefined || e.errorDescription === "")
		        {
		            info("DATA: " + e.buffer.toString());
		            //--
		            try
		            {
		                var s = "Sup world!";
		 
		                var msg = "HTTP/1.1 200 OK\n";
		                msg += "Date: Fri, 31 Dec 1999 23:59:59 GMT\n";
		                msg += "Connection: close\n";
		                msg += "Content-Type: text/html\n";
		                msg += "Content-Length: " + s.length + "\n";
		                msg += "\n";
		                msg += s;
		 
		                sock.write(Ti.createBuffer({value: msg}));
		                sock.close();
		 
		            } catch (e)
		            {
		                info('Exception: ' + e);
		            }
		 
		            //--
		        }
		        else
		        {
		            info("READ ERROR: " + e.errorDescription);
		        }
		    }
		}
		 
		var acceptedCallbacks = {
		    error : function(e)
		    {
		        Ti.API.info(e.error);
		        Ti.UI.createAlertDialog({
		            title:"Socket error: " + e.socket.host,
		            message:e.error
		        }).show();
		    }
		};
		 
		connect();

		return _window;
	}
	
	
	//
	//
	//
	//TIMOB-7850: Android: Can't upload files via HTTPClient (parity issue)
	//
	
	tpl.at.timob7850 = function(_window){
		
		
 
var imageView = Titanium.UI.createImageView({
    image : 'KS_nav_ui.png',
    height : '46dp',
    width : '43dp',
    top:'10dp'
});
 
_window.add(imageView);
 
var button = Titanium.UI.createButton({
    title : 'Click',
    top:'100dp'
});
 
button.addEventListener('click', function() {
    uploadImage();
});
 
_window.add(button);
 
function uploadImage() {
    var request = 'http://app.cardfiler.com/cardfiler/c/' + 'UploadCardPhoto';
    Titanium.API.error('Web Service Call ' + request);
 
    var req = Titanium.Network.createHTTPClient({
        timeout : 60000,
        onload : function(e) {
            Titanium.API.error('Web Service Response - On Image Upload ' + this.responseText);
            var data = JSON.parse(this.responseText)
            if(data.status == true) {
                Titanium.API.error('uToken is ' + Titanium.App.Properties.getString('uToken'));
                var alertDialog = Titanium.UI.createAlertDialog({
                    title : 'Alert',
                    message : data,
                    buttonNames : ['OK']
                });
                alertDialog.show();
            } /* else {
                Titanium.API.error('Response Status false ' + data.message + ' Code ' + data.code);
                var alertDialog = Titanium.UI.createAlertDialog({
                    title : 'Alert',
                    message : data,
                    buttonNames : ['OK']
                });
                alertDialog.show();
            }*/
        },
        onerror : function(e) {
            Titanium.API.error('Web Service Response - On Error' + this.responseText);
            var alertDialog = Titanium.UI.createAlertDialog({
                title : 'Alert',
                message : Titanium.Locale.getString('internet_connection_not_available'),
                buttonNames : ['OK']
            });
            alertDialog.show();
        }
    });
    req.open('POST', request);
    req.setRequestHeader("ContentType", "multipart/form-data");
    req.send({
        'aToken' : '60113f81-6f06-4acc-8002-2c0066f88619',
        'uToken' : '9c7ab91c-fccd-4282-b611-c5dec7e402d8',
        'fileType' : 2,
        'fileObject' : imageView.toBlob()
    });
    }

		
		return _window;
	}
	
	

//
// TIMOB-7939 Android: Tablet timing issue for imageView
//

tpl.at.TIMOB7939 = function(_window) {
	var view = Ti.UI.createView({ left:0, left:10, width: 552, height:90 });
	
	var imageView = Ti.UI.createImageView({
	    top: 10,
	    left: 10,
	    width: 200,
	    height: 200,
	    //image:'http://www.nbc.com/app2/img/120x68xC/scet/metaverse/8/8/8/1/0/vox_74_battle-rounds_02.jpg',
	})
	view.add(imageView);
	_window.add(view);
	_window.open();
	
	var feedRequest = Ti.Network.createHTTPClient({ validatesSecureCertificate:false, timeout: 9000 });
	feedRequest.onerror = function(e) {
	    Ti.API.info('Error:'+e);
	
	};
	
	feedRequest.onload = function(e) {
	    try {
	            var feedContent = (this.responseText.search('//') === -1) ? this.responseText : this.responseText.replace('//', ''); // handle purposefully invalid JSON
	
	           feedContent = JSON.parse(feedContent);
	            imageView.image = feedContent[0].image_url;
	            Ti.API.info('img URL:'+feedContent[0].image_url);
	            feedRequest = null;
	
	    } catch(err) {
	        Ti.API.info('Err:'+err);
	    }
	};

	feedRequest.open('GET', 'http://www.nbc.com/assets/esp/mobile/PortalFeed/portalGetSpotlightV0130/.json');
	feedRequest.send(null);
	return _window;

}


	tpl.at.timob8014 = function(_window) {
		
		_window.backgroundColor = '#fff';
		
		var start = 0;
		
		var textarea = Ti.UI.createTextArea({
		    value: '>>Waiting for response ... \n',
		    left: 0,
		    top: 0,
		    width: '100%',
    		height: '30%'
		});
		
		_window.add(textarea);
		 
		var buffer = Ti.createBuffer();
		var socket = Ti.Network.Socket.createTCP({
		    host: "192.168.100.200",
		    port: 50000,
		    timeout: 10000,
		    connected: function(e) {
		        textarea.value += ">>Connected\n";
		        socket.read(buffer);
		        textarea.value += buffer + "\n";
		    },
		    error: function(e) {
		    	var end = new Date();
		        textarea.value += ">>Socket error:" + e.error + "\n";
		        textarea.value += '>>Time: ' + ((end - start)/1000) + ' sec';
		    }
		});
		 
		
		socket.connect();
		start = new Date();
 		
		return _window;
	};
	
	tpl.at.timob6835 = function(_window){
		
		_window.backgroundColor = 'white';
		
		var text = Ti.UI.createLabel({
			text: '',
		});
		_window.add(text);
		charsetTest("http://kangaechu.com/utf8.html");
		charsetTest("http://kangaechu.com/shiftjis.html");
		charsetTest("http://kangaechu.com/eucjp.html");
		
		function charsetTest(url){
			var xhr = Ti.Network.createHTTPClient();
			
			xhr.onload = function() {
				if(this.status == 200) {
					var html = this.responseText;
					if(html == null){
						text.text = text.text + url + ' is null.\n\n';
					}
					else if(html.match(/<body>([\s\S]*)<\/body>/)){
						var body = RegExp.$1;
						text.text = text.text + url + body;
					}else{
						text.text = text.text + url + ' is 200, but no body element.\n\n';
					}
				}else{
					text.text = text.text + url + ' status code is ' + this.status + '\n\n';
				}
			};
			xhr.onerror = function() {
				text.text = text.text + url + ' status code is ' + this.status + '\n\n';
		
			};
			xhr.open("GET", url, false);
			xhr.send();
			
		}
	
		return _window;
	}
	
	// TIMOB-5807: Returned values should not return null
	tpl.at.timob5807 = function(_window) {
		var url = 'http://tools.dynamicdrive.com/password/example/';
		var request = Titanium.Network.createHTTPClient();
		request.open('GET',url);
		
		//Send
		request.send();
		
		request.onerror = function() {
			if (this.status == 401) {
				var result = 'Server: ' + this.getResponseHeader('Server') + '\n\n' +
			 				 'Connection: ' + this.getResponseHeader('Connection') + '\n\n' +
			 	    		 'WWW-Authenticate: ' +this.getResponseHeader('WWW-Authenticate') + '\n\n' +
			 	    		 'Date: ' + this.getResponseHeader('Date');
				
				var resultLabel = Ti.UI.createLabel({
					text:result,
					height:'auto',
					width:'auto'
				});
			 	
			 	_window.add(resultLabel);
			 }
		}
		
		return _window;
	}
	
	tpl.at.timob4691 = function (_window) {
		_window.backgroundColor = 'red';
		
		var btn = Ti.UI.createButton({
			title:'Get Cache',
			width:200,
			height:30
		});
		
		btn.addEventListener('click', function(){
			var win2 = Ti.UI.createWindow({
				backgroundColor:'blue'
			});
			var btn2 = Ti.UI.createButton({
				title:'close'
			});
			win2.rightNavButton = btn2;
			btn2.addEventListener('click', function(){win2.close();});
			var img = Ti.UI.createImageView({
				top:0,
				right:0,
				left:0,
				bottom:0,
				image:''
			});
			win2.add(img);
			win2.open({modal:true})
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(){
				img.image = this.responseData;
			}
			xhr.open('GET', 'http://jefflynchdev.files.wordpress.com/2009/10/flag_mountain_view_large.jpg');
			xhr.send();
			
		});
		
		_window.add(btn);
		
		return _window;
	};
	
	tpl.at.timob4314 = function(_window){ 
		  
		var webView = Titanium.UI.createWebView({
		    html: '<select name="selectBox"><option value="val1">Value 1</option><option value="val2">Value 2</option><option value="val3">Value 3</option></select>'
		});
		
		_window.add(webView);
		
		webView.setBasicAuthentication('user','pass');
		
		return _window;
	};
	
	//
	// TIMOB-2849 is designed to test set cookie response headers, specifically on Android 
	//
	tpl.at.timob2849 = function(_window){ 
		  
		var testServer = 'http://appc.me/Test/Cookies/';

		//
		// Create a text area to show responses from the server.
		//
		var response = Titanium.UI.createTextArea({
			left : 0,
			right : 0,
			top : 0,
			bottom : 30,
			value : 'Click a button below, and the response from the server will show up here!'
		});
		_window.add(response);

		//
		// Create a button that will hit a page on a test server that echoes any cookies we send it, or sends us two cookies.
		//
		var getOrSetCookies = Titanium.UI.createButton({
			title : 'Get or Set Cookies',
			left : 0,
			bottom : 0,
			width : 150,
			height : 30
		});
		getOrSetCookies.addEventListener('click', function(e) {
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(e) {
				response.value = this.responseText + '\n\nthis.getResponseHeader(\'Set-Cookie\'): ' + this.getResponseHeader('Set-Cookie');
			};
			xhr.open('GET', testServer + '?count=2&clear=false');
			xhr.send();
		});
		_window.add(getOrSetCookies);

		//
		// Create a button that will clear the cookies on the server (set them to expire). It will tell us how many were cleared.
		//
		var clearCookies = Titanium.UI.createButton({
			title : 'Clear Cookies',
			right : 0,
			bottom : 0,
			width : 150,
			height : 30
		});
		clearCookies.addEventListener('click', function(e) {
			var xhr = Ti.Network.createHTTPClient();
			xhr.onload = function(e) {
				response.value = this.responseText + '\n\nthis.getResponseHeader(\'Set-Cookie\'): ' + this.getResponseHeader('Set-Cookie');
			};
			xhr.open('GET', testServer + '?count=2&clear=true');
			xhr.send();
		});
		_window.add(clearCookies);
		
		return _window;
	}
	
	/* TIMOB-6411 is designed to test that HTTPClient on Android isn't outputting
	 * alot of useless errors
	 * 
	 */
	tpl.at.timob6411 = function(_window) {
		
		var xhr = Titanium.Network.createHTTPClient();
		xhr.open('GET', 'http://www.google.com');
		xhr.send();

		return _window;
	}
	
	//TIMOB-6973: test sending a blob as form data does not fail
	tpl.at.timob6973 = function(_window) {
		
		var xhr = Ti.Network.createHTTPClient({
			onload: function() {
				Ti.API.debug('onload');
				Ti.API.debug(this.responseText);	
			},
			onerror: function() {
				Ti.API.debug('onerror');	
			}	
		});
		xhr.setTimeout = 1600000;
		xhr.open('POST', 'http://savagelook.com/xhr_test.php');
		xhr.setRequestHeader("ContentType","multipart/form-data");
		xhr.send({
			somevar: 1,
			someother: 'yoyo',
			blobtest: Ti.UI.createImageView({
				image: 'KS_nav_ui.png',
				height: 200,
				width: 200
			}).toBlob()
		});
		
		return _window;
	};
	
	//TIMOB-6828: Setting request header in HTTPClient to null throws exception

	tpl.at.timob6828 = function(_window) {
		var xhr = Titanium.Network.createHTTPClient();
		xhr.onerror = function(e) {
			alert("ERROR " + e.error);
		};
		xhr.onload = function() {
			alert("Loaded");
		};

		xhr.open('GET', 'http://www.appcelerator.com');
		xhr.setRequestHeader('Authorization', null);
		xhr.send();

		return _window;
	};

// TIMOB-7264: Android: HTTPClient not working for upload files (Parity)
		tpl.at.timob7264 = function(_window) {
		var win = _window;

		
		var image = Titanium.Filesystem.getFile(Titanium.Filesystem.resourcesDirectory,'appc.jpg');
			
		var xhr = Titanium.Network.createHTTPClient();
		
		xhr.onerror = function(e)
		{
			Ti.UI.createAlertDialog({title:'Error', message:e.error}).show();
			Ti.API.info('IN ERROR ' + e.error);
		};
		xhr.setTimeout(20000);
		xhr.onload = function(e)
		{
			Ti.UI.createAlertDialog({title:'Success', message:'status code ' + this.status}).show();
			Ti.API.info('IN ONLOAD ' + this.status + ' readyState ' + this.readyState);
		};
		xhr.onsendstream = function(e)
		{
			Ti.API.info('ONSENDSTREAM - PROGRESS: ' + e.progress);
		};
		
		// open the client
		xhr.open('POST','https://twitpic.com/api/uploadAndPost');
		
		// send the data
		xhr.send({media:image,username:'fgsandford1000',password:'sanford1000',message:'check me out'});
		
		
		return _window;
	}
	
	// TIMOB 9108
	// iOS: Ti.UI.TableView - rows are not highlighted anymore when you change orientation
	//
	tpl.at.timob9108 = function(_window) {
		_window.backgroundColor=  '#ccc';
		 
		Ti.Network.addEventListener("change",function(e) {
		Titanium.API.debug("Network changed");
		setTimeout(function() {
		alert("Network changed (available="+Titanium.Network.online+")");
		},100);
		if (Titanium.Network.online) { Titanium.API.debug("Network is available"); }
		});
		return _window;
	}
	
	// TIMOB-9639: iOS: Network module crash
	tpl.at.timob9639 = function(_window) {
		var text = Ti.UI.createLabel({
    	text: '',
		});
		_window.add(text);
		_window.open();
		charsetTest("http://kangaechu.com/utf8.html");
		charsetTest("http://kangaechu.com/shiftjis.html");
		charsetTest("http://kangaechu.com/eucjp.html");
		charsetTest("http://kangaechu.com/iso2022jp.html");
		  
		function charsetTest(url){
		    var xhr = Ti.Network.createHTTPClient();
		      
		    xhr.onload = function() {
		        if(this.status == 200) {
		            var html = this.responseText;
		            if(html == null){
		                text.text = text.text + url + ' is null.\n\n';
		            }
		            else if(html.match(/<body>([\s\S]*)<\/body>/)){
		                var body = RegExp.$1;
		                text.text = text.text + url + body;
		            }else{
		                text.text = text.text + url + ' is 200, but no body element.\n\n';
		            }
		        }else{
		            text.text = text.text + url + ' status code is ' + this.status + '\n\n';
		        }
		    };
		    xhr.onerror = function() {
		        text.text = text.text + url + ' status code is ' + this.status + '\n\n';
		  
		    };
		    xhr.open("GET", url, false);
		    xhr.send();
		      
		}
		return _window;
	};
	// TIMOB-9864
	// Android: Ti.Network.NETWORK_XXXX property is null
	tpl.at.timob9864 = function(_window) {
		Ti.API.info('NETWORK_NONE : ' + Ti.Network.NETWORK_NONE);
		Ti.API.info('NETWORK_WIFI : ' + Ti.Network.NETWORK_WIFI);
		Ti.API.info('NETWORK_MOBILE : ' + Ti.Network.NETWORK_MOBILE);
		Ti.API.info('NETWORK_LAN : ' + Ti.Network.NETWORK_LAN);
		Ti.API.info('NETWORK_UNKNOWN : ' + Ti.Network.NETWORK_UNKNOWN);
	return _window;
	};
	
	// TIMOB-10036
	// iOS: HTTPClient does not support sending TiFile object as documentation states
	tpl.at.timob10036 = function(_window) {
		var win1=_window;
		var img = Ti.UI.createImageView({
		    image: 'http://www.guestassist.net/images/logo.png',
		    width: 229,
		    height: 66,
		    top: 20
		});
 
		var b1 = Ti.UI.createButton({
		    title: 'upload image',
		    width: 200,
		    height: 40,
		    top: 100
		});
		
		b1.addEventListener('click', uploadImage);
		 
		var link = Ti.UI.createTextField({
		    value: '(url will show here)',
		    top: 160,
		    left: 10,
		    right: 10,
		    height: 60,
		    backgroundColor: 'white',
		    borderColor: '#dddddd',
		    borderWidth: 1,
		    font: {
		        fontSize: 13
		    }
		});
		 
		win1.add(img);
		win1.add(b1);
		win1.add(link);
		win1.open();
		 
		function uploadImage()
		{
		    var http = Ti.Network.createHTTPClient({
		        onerror: function(e) {
		            if (JSON.stringify(e).search('The request timed out') >= 0)
		            {
		                Ti.API.info('timeout');
		            }
		            else
		            {
		                Ti.API.info('error');
		            }
		        },
		        onload: function(e) {
		            Ti.API.info('success!');
		        },
		        enableKeepAlive: false,
		        timeout: 360000
		    });
		     
		     
		    Ti.App.idleTimerDisabled = true;
		    var d = new Date();
		    var raw = d.getTime();
		    var filename = raw + '.png';
		     
		    var f = Ti.Filesystem.getFile(Ti.Filesystem.tempDirectory + '/' + filename);
		    f.write(img.toBlob());
		     
		    var uploadFile = Ti.Filesystem.getFile(Ti.Filesystem.tempDirectory, filename);
		    if (!uploadFile.exists()) { alert('file not found'); return false; }
		    var fileContents = uploadFile.read();
		    var curDate = 'Wed, 19 June 2011 10:00:00 -0500'; // hard coding date in AWS format for testing
		    var fileURL = 'https://s3.amazonaws.com/ga-testbucket/images/' + filename;
		             
		    http.open('PUT', fileURL, false);
		    http.setRequestHeader('Content-Type', fileContents.mimeType);
		    if (Ti.Platform.osname != 'android')
		    {
		        http.setRequestHeader('Content-Length', uploadFile.size);
		    }
		    http.setRequestHeader('Host', 's3.amazonaws.com');
		    http.setRequestHeader('Date', curDate);
		    http.setRequestHeader('x-amz-acl', 'public-read');
		    http.send(uploadFile); // TiFile
		     
		    alert('image uploaded!');
		    link.value = fileURL;
		}
	return win1;
	};
})();